using System;
using System.Collections;
using Server;
using Server.Targeting;
using Server.Mobiles;
using Server.Gumps;
using Server.Network;
using Server.Items;

namespace Server.Custom
{
	public class GiveExperience
	{ 
		public static void toMobile(Mobile m, BaseCreature creature)
		{
			if (creature.IsBonded) return;
			
			double m_Exp; //Holds the Experience to Gain
			double m_Stats; //Stores various creature stats

			m_Stats = creature.PhysicalResistance + creature.FireResistance + 
					creature.ColdResistance + creature.PoisonResistance + creature.EnergyResistance;
			if (m_Stats < 100.0) m_Stats = 100.0;
			int m_Hits = creature.HitsMax/10;
			m_Exp = m_Hits + ((m_Hits * m_Stats)/100);
						
			m_Stats = creature.Fame;
			if (creature.Karma < 0) m_Stats -= creature.Karma;
			else m_Stats += creature.Karma;
			m_Stats = m_Stats/250;
			m_Exp += m_Stats;

			if (creature.AI == AIType.AI_Mage)
			{
				m_Stats = ((creature.Skills[SkillName.Meditation].Value + creature.Skills[SkillName.Magery].Value + creature.Skills[SkillName.EvalInt].Value)/30);
				m_Exp += m_Stats;
			}
			
			if (creature.HasBreath)
			{
				m_Stats = (creature.HitsMax/25);
				m_Exp += m_Stats;
			}
							
			int m_TempExp = ((int)m_Exp);
			m_TempExp = (Utility.RandomMinMax((m_TempExp-m_TempExp/50), (m_TempExp-m_TempExp/7))/2);
			if (m_TempExp < 1) m_TempExp = 1;
			
			RewardExperience(m, m_TempExp);
		}

		public static void RewardExperience(Mobile mob, int amount)
		{
			NewMobile m;
			if (mob is NewMobile)
			{
				m = mob as NewMobile;
				m._Experience += amount;
				m.SendMessage( 1173, "You {1} {0} Experience.", amount, amount < 0 ? "lost":"gained" );
				if ( m.NewLevel.CanGainLevel( m ) )
					m.SendMessage( 1173, "Double-click the Class Stone to Level Up!");
			}
			//else return; //There was no primary NewMobile Aggressor

		}
	}
}