using System;
using System.Collections;
using Server;
using Server.Gumps;
using Server.Mobiles;
using Server.Network;

namespace Server.Custom
{
	public class ChooseRaceGump : Gump
	{
		private NewMobile m_Mobile;

		public ChooseRaceGump( NewMobile mobile ) : base( 50, 50 )
		{
			mobile.CloseGump( typeof( ChooseRaceGump ) );

			m_Mobile = mobile;

			AddPage( 0 );

			AddBackground( 0, 0, 476, 270, 0x13BE );

			AddImageTiled( 150, 30, 316, 205, 0xA40 );
			AddAlphaRegion( 150, 30, 316, 205 );

			AddLabel( 10, 7, 2100, "Choose Race" );

			string description = RaceEntry.GetEntry( m_Mobile._Race ).Description;

			AddHtml( 160, 40, 296, 185, description, true, true );

			AddImageTiled( 10, 30, 101, 230, 0xA40 );
			AddAlphaRegion( 10, 30, 101, 230 );

			AddButton( 436, 240, 0xFB7, 0xFB9, 1, GumpButtonType.Reply, 0 );
			
			// List races
			
			int count = 0;
				
			foreach( RaceEntry race in RaceEntry.Table.Values )
			{
				int y = 30 * (++count);
				AddButton( 115, y, 0xFAE, 0xFB0, (int)race.Race + 2, GumpButtonType.Reply, 0 );
				AddLabel( 15, y, race.Race == m_Mobile._Race ? 2124 : 2100, race.Name );
			}
		}

		public override void OnResponse( NetState state, RelayInfo info )
		{
			char[] vowels = new Char[]{'A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o', 'u'};
			Race r = m_Mobile._Race;

			if ( info.ButtonID == 1 )
			{
				m_Mobile.SendMessage("You are now {1} {0}!", r.ToString(),
					r.ToString().LastIndexOfAny( vowels, 0, 1 ) > 0 ? "an" : "a" );
				m_Mobile.CloseGump( typeof( ChooseRaceGump ) );
				m_Mobile.SendGump( new RaiseStatsGump( m_Mobile ) );
			}
			else if ( info.ButtonID >= 2 )
			{
				m_Mobile._Race = (Race)(info.ButtonID - 2);
				m_Mobile.SendGump( new ChooseRaceGump( m_Mobile ) );
			}
			else
			{
				m_Mobile.SendMessage("Canceled.");
			}
		}
	}
}