using System;
using Server.Gumps;
using Server.Items;
using Server.Mobiles;
using Server.Network;

namespace Server.Custom
{
	public class CustomClassStone : Item
	{
		[Constructable]
		public CustomClassStone() : base( 0xED4 )
		{
			Movable = false;
			Hue = 0x489;
			Name = "a class stone";
		}

		public CustomClassStone( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public override void OnDoubleClick( Mobile m )
		{
			if ( !( m is NewMobile ) )
			{
				m.SendMessage( "You may not use this Stone!");
				return;
			}
			
			NewMobile from = m as NewMobile;
			if ( from._Race == Race.None )
			{
				from.SendMessage( "You must choose a Race before you can choose a Class!" );
			}
			else from.SendGump( new ChooseClassGump( from, false ) );
		}
	}
}