using System;
using Server.Gumps;
using Server.Items;
using Server.Mobiles;
using Server.Network;

namespace Server.Custom
{
	public class CustomRaceStone : Item
	{
		[Constructable]
		public CustomRaceStone() : base( 0xED4 )
		{
			Movable = false;
			Hue = 0x489;
			Name = "a race choosing stone";
		}

		public CustomRaceStone( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public override void OnDoubleClick( Mobile m )
		{
			if ( !( m is NewMobile ) )
			{
				m.SendMessage( "You may not use this Stone!");
				return;
			}
			
			NewMobile from = m as NewMobile;
			if ( from._Race != Race.None )
			{
				from.SendMessage( "You have already chosen to be {0}!", from._Race.ToString() );
			}
			else from.SendGump( new ChooseRaceGump( from ) );
		}
	}
}