using Server;
using System;

namespace Server.Custom
{
    public class NewSkillInfo
    {
		private int m_NewSkillID;
		private string m_Name;
		private double m_StrMod;
		private double m_DexMod;
		private double m_IntMod;
		private double m_ConMod;
		private double m_ChaMod;
		private double m_WisMod;
		private string m_Title;
		private bool m_ClickToUse;
		private SkillUseCallback m_Callback;
        private static NewSkillInfo[] m_Table;

        public int NewSkillID {get{return m_NewSkillID;}}
        public string Name {get{return m_Name;}set{m_Name = value;}}
        public string Title {get{return m_Title;}set{m_Title = value;}}
        public double StrMod {get{return m_StrMod;}set{m_StrMod = value;}}
        public double DexMod {get{return m_DexMod;}set{m_DexMod = value;}}
        public double IntMod {get{return m_IntMod;}set{m_IntMod = value;}}
        public double ConMod {get{return m_ConMod;}set{m_ConMod = value;}}
        public double ChaMod {get{return m_ChaMod;}set{m_ChaMod = value;}}
        public double WisMod {get{return m_WisMod;}set{m_WisMod = value;}}
        public bool ClickToUse {get{return m_ClickToUse;}set{m_ClickToUse = value;}}
		public SkillUseCallback Callback{get{return m_Callback;}set{m_Callback = value;}}
        public static NewSkillInfo[] Table {get{return NewSkillInfo.m_Table;}set{NewSkillInfo.m_Table = value;}}

        public NewSkillInfo(int newSkillID, string name, double strMod, double dexMod, double intMod, double conMod, double chaMod, double wisMod, string title, bool clickToUse, SkillUseCallback callback)
		{
			m_NewSkillID = newSkillID;
            m_Name = name;
            m_StrMod = strMod;
            m_DexMod = dexMod;
            m_IntMod = intMod;
            m_ConMod = conMod;
            m_ChaMod = chaMod;
			m_WisMod = wisMod;
			m_Title = title;
			m_Callback = callback;
            m_ClickToUse = clickToUse;
        }

        static NewSkillInfo()
        {
			// When these skills are implemented, if there is direct-use code for the skill,
			//   change the boolean value to 'true'
			NewSkillInfo[] skillarray;
			skillarray = new NewSkillInfo[60];
			skillarray[0] = new NewSkillInfo(0, "Gardening",0,0,0,0,0,0, "Naturalist",true, null);
			skillarray[1] = new NewSkillInfo(1, "Forestry",0,0,0,0,0,0, "Naturalist",true, null);
			skillarray[2] = new NewSkillInfo(2, "Taxidermy",0,0,0,0,0,0, "Naturalist",true, null);
			skillarray[3] = new NewSkillInfo(3, "Boating",0,0,0,0,0,0, "Naturalist",false, null);
			skillarray[4] = new NewSkillInfo(4, "Sailing",0,0,0,0,0,0, "Naturalist",false, null);
			skillarray[5] = new NewSkillInfo(5, "Bonus Strike",0,0,0,0,0,0, "Warrior",false, null);
			skillarray[6] = new NewSkillInfo(6, "Increased Accuracy",0,0,0,0,0,0, "Warrior",false, null);
			skillarray[7] = new NewSkillInfo(7, "Double Damage",0,0,0,0,0,0, "Warrior",false, null);
			skillarray[8] = new NewSkillInfo(8, "Improved Strength",0,0,0,0,0,0, "Warrior",false, null);
			skillarray[9] = new NewSkillInfo(9, "Triple Strike",0,0,0,0,0,0, "Warrior",false, null);
			skillarray[10] = new NewSkillInfo(10, "Detect Evil",0,0,0,0,0,0, "Paladin",false, null);
			skillarray[11] = new NewSkillInfo(11, "Horse Back Riding",0,0,0,0,0,0, "Paladin",false, null);
			skillarray[12] = new NewSkillInfo(12, "Lay On Hands",0,0,0,0,0,0, "Paladin",true, null);
			skillarray[13] = new NewSkillInfo(13, "Divine Health",0,0,0,0,0,0, "Paladin",true, null);
			skillarray[14] = new NewSkillInfo(14, "Remove Disease",0,0,0,0,0,0, "Paladin",true, null);
			skillarray[15] = new NewSkillInfo(15, "Martial Arts",0,0,0,0,0,0, "Assassin",false, null);
			skillarray[16] = new NewSkillInfo(16, "Wounding Strike",0,0,0,0,0,0, "Assassin",false, null);
			skillarray[17] = new NewSkillInfo(17, "Crippling Strike",0,0,0,0,0,0, "Assassin",false, null);
			skillarray[18] = new NewSkillInfo(18, "Critical Strike",0,0,0,0,0,0, "Assassin",false, null);
			skillarray[19] = new NewSkillInfo(19, "Mortal Strike",0,0,0,0,0,0, "Assassin",false, null);
			skillarray[20] = new NewSkillInfo(20, "Pick Pocket",0,0,0,0,0,0, "Rogue",true, null);
			skillarray[21] = new NewSkillInfo(21, "Acrobatics",0,0,0,0,0,0, "Rogue",false, null);
			skillarray[22] = new NewSkillInfo(22, "Gambling",0,0,0,0,0,0, "Rogue",false, null);
			skillarray[23] = new NewSkillInfo(23, "Sneak Attack",0,0,0,0,0,0, "Rogue",false, null);
			skillarray[24] = new NewSkillInfo(24, "Defensive Roll",0,0,0,0,0,0, "Rogue",false, null);
			skillarray[25] = new NewSkillInfo(25, "Fast Movement",0,0,0,0,0,0, "Monk",false, null);
			skillarray[26] = new NewSkillInfo(26, "Dodge",0,0,0,0,0,0, "Monk",false, null);
			skillarray[27] = new NewSkillInfo(27, "Damage Reduction",0,0,0,0,0,0, "Monk",false, null);
			skillarray[28] = new NewSkillInfo(28, "Improved Dodge",0,0,0,0,0,0, "Monk",false, null);
			skillarray[29] = new NewSkillInfo(29, "Strong Will",0,0,0,0,0,0, "Monk",false, null);
			skillarray[30] = new NewSkillInfo(30, "Poetry",0,0,0,0,0,0, "Bard",false, null);
			skillarray[31] = new NewSkillInfo(31, "Singing",0,0,0,0,0,0, "Bard",false, null);
			skillarray[32] = new NewSkillInfo(32, "Dancing",0,0,0,0,0,0, "Bard",false, null);
			skillarray[33] = new NewSkillInfo(33, "Languages",0,0,0,0,0,0, "Bard",false, null);
			skillarray[34] = new NewSkillInfo(34, "Disguise",0,0,0,0,0,0, "Bard",false, null);
			skillarray[35] = new NewSkillInfo(35, "Ventriloquism",0,0,0,0,0,0, "Illusionist",true, null);
			skillarray[36] = new NewSkillInfo(36, "Hypnotism",0,0,0,0,0,0, "Illusionist",true, null);
			skillarray[37] = new NewSkillInfo(37, "Sleight Of Hand",0,0,0,0,0,0, "Illusionist",true, null);
			skillarray[38] = new NewSkillInfo(38, "Make Disappear",0,0,0,0,0,0, "Illusionist",true, null);
			skillarray[39] = new NewSkillInfo(39, "Levitation",0,0,0,0,0,0, "Illusionist",true, null);
			skillarray[40] = new NewSkillInfo(40, "Prey Tracking",0,0,0,0,0,0, "Ranger",false, null);
			skillarray[41] = new NewSkillInfo(41, "Camouflage",0,0,0,0,0,0, "Ranger",false, null);
			skillarray[42] = new NewSkillInfo(42, "Jumping",0,0,0,0,0,0, "Ranger",false, null);
			skillarray[43] = new NewSkillInfo(43, "Setting Traps",0,0,0,0,0,0, "Ranger",false, null);
			skillarray[44] = new NewSkillInfo(44, "Speak To Animals",0,0,0,0,0,0, "Ranger",true, null);
			skillarray[45] = new NewSkillInfo(45, "Wood Carving",0,0,0,0,0,0, "Tinker",true, null);
			skillarray[46] = new NewSkillInfo(46, "Key Making",0,0,0,0,0,0, "Tinker",false, null);
			skillarray[47] = new NewSkillInfo(47, "Engineering",0,0,0,0,0,0, "Tinker",false, null);
			skillarray[48] = new NewSkillInfo(48, "Silver Smithing",0,0,0,0,0,0, "Tinker",true, null);
			skillarray[49] = new NewSkillInfo(49, "Gold Crafting",0,0,0,0,0,0, "Tinker",true, null);
			skillarray[50] = new NewSkillInfo(50, "Negotiation",0,0,0,0,0,0, "Merchant",true, null);
			skillarray[51] = new NewSkillInfo(51, "Accounting",0,0,0,0,0,0, "Merchant",false, null);
			skillarray[52] = new NewSkillInfo(52, "Brewing",0,0,0,0,0,0, "Merchant",true, null);
			skillarray[53] = new NewSkillInfo(53, "Herblaw",0,0,0,0,0,0, "Merchant",true, null);
			skillarray[54] = new NewSkillInfo(54, "Commerce",0,0,0,0,0,0, "Merchant",false, null);
			skillarray[55] = new NewSkillInfo(55, "History",0,0,0,0,0,0, "Cleric",false, null);
			skillarray[56] = new NewSkillInfo(56, "Healing Arts",0,0,0,0,0,0, "Cleric",true, null);
			skillarray[57] = new NewSkillInfo(57, "Theology",0,0,0,0,0,0, "Cleric",false, null);
			skillarray[58] = new NewSkillInfo(58, "Heraldry",0,0,0,0,0,0, "Cleric",false, null);
			skillarray[59] = new NewSkillInfo(59, "Writing",0,0,0,0,0,0, "Cleric",false, null);
			NewSkillInfo.m_Table = skillarray;
        }
    }

}

