using System;
using Server;

namespace Server.Custom
{
	public enum NewSkillName
	{
		// Naturalist Skills	
		Gardening	= 0,
		Forestry	,
		Taxidermy	,
		Boating	,
		Sailing	,
			
		// Warior Skills	
		BonusStrike	,
		IncreasedAccuracy	,
		DoubleDamage	,
		ImprovedStrength	,
		TripleStrike	,
			
		// Paladin Skills	
		DetectEvil	,
		HorseBackRiding	,
		LayOnHands	,
		DivineHealth	,
		RemoveDisease	,
			
		// Assassin Skills	
		MartialArts	,
		WoundingStrike	,
		CripplingStrike	,
		CriticalStrike	,
		MortalStrike	,
			
		// Rogue Skills	
		PickPocket	,
		Acrobatics	,
		Gambling	,
		SneakAttack	,
		DefensiveRoll	,
			
		// Monk Skills	
		FastMovement	,
		Dodge	,
		DamageReduction	,
		ImprovedDodge	,
		StrongWill	,
			
		// Bard Skills	
		Poetry	,
		Singing	,
		Dancing	,
		Languages	,
		Disguise	,
			
		// Illusionist Skills	
		Ventriloquism	,
		Hypnotism	,
		SleightOfHand	,
		MakeDisappear	,
		Levitation	,
			
		// Ranger Skills	
		PreyTracking	,
		Camouflage	,
		Jumping	,
		SettingTraps	,
		SpeakToAnimals	,
			
		// Tinker Skills
		WoodCarving	,
		KeyMaking	,
		Engineering	,
		SilverSmithing	,
		GoldCrafting	,
			
		// Merchant Skills	
		Negotiation	,
		Accounting	,
		Brewing	,
		Herblaw	,
		Commerce	,
			
		// Cleric Skills	
		History	,
		HealingArts	,
		Theology	,
		Heraldry	,
		Writing	,
			
		// Magician Skills	
		FeatherLight	,
		WalkThroughWalls	,
		EnchantItem	,
		FleshToStone	,
		Transmutation	,
			
		// Scholar Skills	
		Teaching	,
		Diplomacy	,
		Administration	,
		Cyphering	,
		Linguistics
	}

	public struct NewSkillNameValue
	{
		public NewSkillName Name;
		public int Value;

		public NewSkillNameValue(NewSkillName name, int val) 
		{
			Name = name;
			Value = val;    
		} 
	}

	public class SkillEntry
	{
		private Class m_Class;
		public Class Class{ get { return m_Class; } set { m_Class = value; } }
		private SkillNameValue[] m_Snv;
		public SkillNameValue[] ClassSkills{ get { return m_Snv; } set { m_Snv = value; } }
		private NewSkillNameValue[] m_NewSnv;
		public NewSkillNameValue[] NewClassSkills{ get { return m_NewSnv; } set { m_NewSnv = value; } }
		private int skillCount;
		public int SkillCount{ get { return skillCount; } set { skillCount = value; } }
		private int newSkillCount;
		public int NewSkillCount{ get { return newSkillCount; } set { newSkillCount = value; } }

		public SkillEntry( Class clas, int count, SkillNameValue[] snv )
		{
			skillCount = count;
			newSkillCount = 0;
			m_Class = clas;
			m_Snv = new SkillNameValue[count];
			if (count > 0) for (int x=0; x<count; x++)
				m_Snv[x] = new SkillNameValue(snv[x].Name, snv[x].Value);
		}

		public SkillEntry( Class clas, int newCount, NewSkillNameValue[] newSnv )
		{
			skillCount = 0;
			newSkillCount = newCount;
			m_Class = clas;
			m_NewSnv = new NewSkillNameValue[newCount];
			if (newCount > 0) for (int x=0; x<newCount; x++)
								  m_NewSnv[x] = new NewSkillNameValue(newSnv[x].Name, newSnv[x].Value);
		}

		public SkillEntry( Class clas, int count, SkillNameValue[] snv, int newCount, NewSkillNameValue[] newSnv )
		{
			skillCount = count;
			newSkillCount = newCount;
			m_Class = clas;
			m_Snv = new SkillNameValue[count];
			if (count > 0) for (int x=0; x<count; x++)
							   m_Snv[x] = new SkillNameValue(snv[x].Name, snv[x].Value);
			m_NewSnv = new NewSkillNameValue[newCount];
			if (newCount > 0) for (int x=0; x<newCount; x++)
							   m_NewSnv[x] = new NewSkillNameValue(newSnv[x].Name, newSnv[x].Value);
		}
	}
}